Loading...
Searching...
No Matches
visitor.hh File Reference
`#include <dune/typetree/treepath.hh>`
`#include <dune/common/hybridutilities.hh>`

Go to the source code of this file.

## Classes

struct | Dune::TypeTree::DefaultVisitor
| Visitor interface and base class for TypeTree visitors. More...
struct | Dune::TypeTree::DefaultPairVisitor
| Visitor interface and base class for visitors of pairs of TypeTrees. More...
struct | Dune::TypeTree::Experimental::DefaultHybridVisitor
| Hybrid visitor interface and base class for TypeTree hybrid visitors. More...
struct | Dune::TypeTree::VisitDirectChildren
| Mixin base class for visitors that only want to visit the direct children of a node. More...
struct | Dune::TypeTree::VisitDirectChildren::VisitChild< Node1, Child1, Node2, Child2, TreePath >
| Template struct for determining whether or not to visit a given child. More...
struct | Dune::TypeTree::VisitTree
| Mixin base class for visitors that want to visit the complete tree. More...
struct | Dune::TypeTree::VisitTree::VisitChild< Node1, Child1, Node2, Child2, TreePath >
| Template struct for determining whether or not to visit a given child. More...
struct | Dune::TypeTree::StaticTraversal
| Mixin base class for visitors that require a static TreePath during traversal. More...
struct | Dune::TypeTree::DynamicTraversal
| Mixin base class for visitors that only need a dynamic TreePath during traversal. More...
struct | Dune::TypeTree::TreeVisitor
| Convenience base class for visiting the entire tree. More...
struct | Dune::TypeTree::DirectChildrenVisitor
| Convenience base class for visiting the direct children of a node. More...
struct | Dune::TypeTree::TreePairVisitor
| Convenience base class for visiting an entire tree pair. More...
struct | Dune::TypeTree::DirectChildrenPairVisitor
| Convenience base class for visiting the direct children of a node pair. More...
struct | Dune::TypeTree::Experimental::Info::LeafCounterVisitor
struct | Dune::TypeTree::Experimental::Info::NodeCounterVisitor
struct | Dune::TypeTree::Experimental::Info::DepthVisitor

## Namespaces

namespace | Dune
namespace | Dune::TypeTree
namespace | Dune::TypeTree::Experimental
namespace | Dune::TypeTree::Experimental::Info

## Functions

template<typename Tree>
auto | Dune::TypeTree::Experimental::Info::depth (const Tree &tree)
| The depth of the TypeTree.
template<typename Tree>
constexpr auto | Dune::TypeTree::Experimental::Info::depth ()
| The depth of the Tree.
template<typename Tree>
auto | Dune::TypeTree::Experimental::Info::nodeCount (const Tree &tree)
| The total number of nodes in the Tree.
template<typename Tree>
auto | Dune::TypeTree::Experimental::Info::leafCount (const Tree &tree)
| The number of leaf nodes in the Tree.

## Variables

template<typename Tree>
constexpr bool | Dune::TypeTree::Experimental::Info::isDynamic = std::is_same<std::size_t, decltype(leafCount(std::declval<Tree>()))>{}
| true if any of the nodes in the tree only has dynamic degree.